function [expleft,expright]=bmsc104anew
% In this exercise we simulated the expectation of $cos( \int_0^1 s ds +
% B_1) where B is a P-BM by using Girsanov's Theorem, that is we check it
% is equal to E[exp(\int_0^1 s dB_s -1/2 \int_0^1 a_s^2 ds)  cos (B_1)].
tic
%% parameter input
% horizon
T=1;
% sample size
Nplot=10^4;
% grid points
M=10^3;
% time step
dt= T/M;

%% Simulation
% BM
PBM = [zeros(1,Nplot);sqrt(T/M)*cumsum(randn(M,Nplot))];

% approximation of the integral \int_0^1 s dB_s (cf. EX 8-4)
agrid = repmat((0:dt:T)',1,Nplot);
Int = [zeros(1,Nplot);cumsum(agrid(1:(end-1),:).*(PBM(2:end,:)-PBM(1:(end-1),:)))];
% weights= exp(int_0^1 s d B_s-1/2 \int_0^1 s^2 ds
weights = (exp(Int(end,:)-1/6));

% LHS of (1)
expleft= mean(cos(PBM(end,:)+1/2));
% RHS of (1)
expright= mean(weights.* cos(PBM(end,:)));

toc